/****************************************************************************/

#include "genapp.h"

/****************************************************************************/

// Global variable declarations
HINSTANCE hInst=NULL;
char      szAppName[50]="";
char      szTitle[120]="";
HWND      hwndMain=NULL;

/*****************************************************************************
 * Name         - InitApplication
 * Purpose      - This function takes all of the steps neccesary to get the
 *                application up and running. By the time it has ended, the
 *                window is on the screen and ready to go.
 * Arguments    - hInstance: Instance handle of the program
 *                nCmdShow: Initial show state for the main window
 * Return Value - TRUE on success or FALSE on failure
 ****************************************************************************/
BOOL initApplication (HINSTANCE hInstance , char * /*CmdLine*/ , int nCmdShow)
{
    CWindowClass wc (wndProc , IDS_CLASSNAME , hInstance);

    // Save the instance handle in static variable, which will be used in
    // many subsequence calls from this application to Windows.
    hInst = hInstance;

    // Load the application name and window title strings.
    CResString classStr (hInst , IDS_CLASSNAME , szAppName , sizeof (szAppName));
    CResString title    (hInst , IDS_TITLETEXT , szTitle , sizeof (szTitle));

    // The class defaults everthing based on the usual defaults and the
    // information given in the constructor. Change the things that aren't
    // set to default manually.
    wc.setStyle (CS_HREDRAW | CS_VREDRAW);
    wc.setMenu (IDM_MAINMENU);
    wc.setResIcons (IDI_MAINICON);

    // Register the window class and return FALSE if unsuccesful.
    if (!wc.registerClass ())
     return FALSE;

    // Create a main window for this application instance.
    hwndMain = CreateWindow (szAppName,           // Class name
                             title,               // Text for window title bar
                             WS_OVERLAPPEDWINDOW, // Window style
                             CW_USEDEFAULT, 0,    // Use default positioning
                             CW_USEDEFAULT, 0,    // Use default size
                             NULL,                // Overlapped has no parent
                             NULL,                // Use the window class menu
                             hInst,               // This instance owns this window
                             NULL);               // Don't need data in WM_CREATE

    // If window could not be created, return "failure"
    if (!hwndMain)
        return FALSE;

    // Update the window
    ShowWindow (hwndMain , nCmdShow);
    UpdateWindow (hwndMain);

    return TRUE;
}

/****************************************************************************/

