/****************************************************************************/

#include "winlib.h"

/*****************************************************************************
 * Name         - winLibNewHandler
 * Purpose      - This is the new handler installed when WinLib is initialized
 *                in WinMain. It throws an exception indicating that the
 *                new allocation failed. This will terminate the program.
 * Arguments    - Never Used
 * Return Value - Never used
 ****************************************************************************/
INT winLibNewHandler (size_t /*Size*/)
{
 throw CException  ("New: Out of memory!");
}

/*****************************************************************************
 * Name         - resThrow
 * Purpose      - This function uses it's parameters to load a resource string
 *                into a static character buffer, and then uses that buffer
 *                to throw an exception.
 * Arguments    - hInst: Instance handle of the program
 *                resId: The resource ID of the exeption strnig
 *                useCode: If YES, the error code obtained from GetLastError
 *                         is used to fill in the error code of the exception.
 *                         If NO, the error code is set to 0.
 * Return Value - Never used
 ****************************************************************************/
void resThrow (HINSTANCE hInst , INT resId , BOOL useCode/*=YES*/)
{
 static CHAR exceptBuf[1024];

 CResString exceptString (hInst , resId , exceptBuf , sizeof (exceptBuf));

 if (useCode)
     throw CException (exceptBuf);
 else
     throw CException (exceptBuf , 0);
}

/****************************************************************************/

