#ifndef __WINCLASSdotH__
#define __WINCLASSdotH__

class CWindowClass: public WNDCLASSEX
{
public:
    CWindowClass (WNDPROC WndProc , INT ClassId , HINSTANCE hInst);
    CWindowClass (WNDPROC WndProc , CHAR *strClassName , HINSTANCE hInst);

    void setResIcons (CHAR *resName);
    void setResIcons (int resId);
    BOOL registerClass (void);
    inline void setStyle (UINT style);
    inline void setBgSysColor (INT sysColor);
    inline void setMenu (INT resId);
    inline void setMenu (CHAR *resName);
private:
    CResString className;
};

/*****************************************************************************
 * Name         - CWindowClass::setStyle
 * Purpose      - This function changes the style of the class to the new
 *                passed in style.
 * Arguments    - newStyle: The new style to set in the class
 * Return Value - None
 ****************************************************************************/
inline void CWindowClass::setStyle (UINT newStyle)
{
 style = newStyle;
}

/*****************************************************************************
 * Name         - CWindowClass::setBgSysColor
 * Purpose      - Changes the background color of the window to the specified
 *                System color. Note that the function automatically adds 1 to
 *                the color passed in, so call it with, for example
 *                COLOR_APPWORKSPACE and not COLOR_APPWORKSPACE + 1. There is
 *                currently no member function to change the background brush
 *                directly. You can do that in the standard way.
 * Arguments    - sysColor: The new color to use
 * Return Value - None
 ****************************************************************************/
inline void CWindowClass::setBgSysColor (INT sysColor)
{
 hbrBackground = (HBRUSH) (sysColor + 1);
}

/*****************************************************************************
 * Name         - CWindowClass::setMenu
 * Purpose      - Sets the menu name of the window class to the menu
 *                identified by the passed in resource ID.
 * Arguments    - resId: The numeric ID of the main menu resource
 * Return Value - None
 ****************************************************************************/
inline void CWindowClass::setMenu (INT resId)
{
 setMenu (MAKEINTRESOURCE (resId));
}

/*****************************************************************************
 * Name         - CWindowClass::setMenu
 * Purpose      - Sets the menu name of the window class to the menu
 *                identified by the passed in resource name. This function
 *                works similar to the above function, with the exception that
 *                it takes a string as a resource name instead of an integer.
 * Arguments    - resName: String containing the menu name
 * Return Value - None
 ****************************************************************************/
inline void CWindowClass::setMenu (CHAR *resName)
{
 lpszMenuName = resName;
}

/****************************************************************************/

#endif
