#include "winlib.h"

/*****************************************************************************
 * Name         - CResString::init
 * Purpose      - This is the one function that does all the work for the
 *                class. It first loads the string into it's own internal
 *                buffer. After that, if a secondary buffer was specified
 *                (Buf != NULL), the loaded data is copied to that buffer as
 *                well. In this case, BufLen is the maximum size of Buf, and
 *                takes the NULL terminator byte into account.
 * Arguments    - hInst: Instance handle to load the string from
 *                ResId: Resource ID of the string to load
 *                userBuf: Pointer to extra bufffer
 *                BufLen: Size of extra buffer in bytes
 * Return Value - None
 ****************************************************************************/
void CResString::init (HINSTANCE hInst, INT resId , CHAR *userBuf , INT bufLen)
{
 static CHAR errorBuf[256];

 if (!LoadString (hInst , resId , buf , MAX_RESSTRING + 1)) {
     wsprintf (errorBuf , "LoadString failed: ID %d" , resId);
     throw CException (errorBuf);
 }

 if (userBuf) {
     strncpy (userBuf , buf , bufLen);
     userBuf[bufLen - 1] = '\0';
 }
}

/****************************************************************************/

